create or replace PROCEDURE MHA_IMPORTA_RET_SEPARACAO(XML_ARQ IN CLOB,
                                    P_ERRO OUT VARCHAR2,
                                    P_SEQLOG NUMBER DEFAULT -1)
IS
   L_XMLTYPE XMLTYPE;

   V_CDPRODUTO    VARCHAR2(10);
   V_ERRO         VARCHAR2(1);
   V_DESCERRO     VARCHAR2(4000);

   V_CDFILIAL     VARCHAR2(4);
   V_PEDIDO       VARCHAR2(18);
   V_CDFILDEST    VARCHAR2(4);
   V_CDFILLANC    VARCHAR2(4);
   V_NRPEDEXOL    VARCHAR2(18);

   V_CODPRODUTO   VARCHAR2(20);
   V_QUANTIDADE   FLOAT;

   V_PEDEXISTE    VARCHAR2(04);

   V_NRPEDEXOLANT VARCHAR2(18);
   V_SEQLOGITEM   NUMBER;

   V_IDEXISTEPED   VARCHAR2(01);

   CURSOR C_RET_SEPARACAO IS
      SELECT F.CDFILIAL, A.ORDEMCARREGAMENTO, SUBSTR(A.ORDEMCARREGAMENTO,1,4) AS CDFILDEST,
             SUBSTR(A.ORDEMCARREGAMENTO,5,4) AS CDFILLANC,
             SUBSTR(A.ORDEMCARREGAMENTO,9,10) AS NRPEDEXOL,
             SUBSTR(A.CODPRODUTO, 1, 20),
             A.QUANTIDADE
        FROM RETORNO_ARQ_SEPARA A, FILIAL F, PARAMFILIAL R
       WHERE R.CDFILWMSMHA = A.FILIAL
         AND R.CDFILIAL = F.CDFILIAL
       ORDER BY F.CDFILIAL, A.ORDEMCARREGAMENTO, A.CODPRODUTO;

   PROCEDURE INSERE_LOGITEM(P_SEQLOGITEM OUT NUMBER)
   IS
   BEGIN
      IF (P_SEQLOG > -1) THEN
         SELECT MAX(SEQLOGITEM)+1
           INTO P_SEQLOGITEM
           FROM USR_LOGITEM_INTEGRACAO;
         BEGIN
            INSERT INTO USR_LOGITEM_INTEGRACAO(SEQLOG, SEQLOGITEM, CDDADOS, HORAENV, HORAREC)
            VALUES(P_SEQLOG, P_SEQLOGITEM, V_PEDIDO,  SYSDATE, SYSDATE);
         EXCEPTION
            WHEN OTHERS THEN
               P_SEQLOGITEM := NULL;
         END;
      ELSE
         P_SEQLOGITEM := NULL;
      END IF;
   END;
BEGIN
   DELETE FROM RETORNO_ARQ_SEPARA;
   L_XMLTYPE := XMLTYPE(XML_ARQ);

   V_NRPEDEXOLANT := '000000000000000000';

   FOR C_XML IN (SELECT EXTRACTVALUE(VALUE(P), '/RET_SEPARACAO/EMPRESA/text()') AS EMPRESA
                        ,EXTRACTVALUE(VALUE(P), '/RET_SEPARACAO/FILIAL/text()') AS FILIAL
                        ,EXTRACTVALUE(VALUE(P), '/RET_SEPARACAO/ListRemess/ListRemess/DOCUMENTOREMESSA/text()') AS ORDEMCARREGAMENTO
                        ,EXTRACTVALUE(VALUE(P), '/RET_SEPARACAO/DEPOSITO_ERP/text()') AS DEPOSITO_ERP
                        ,EXTRACT(VALUE(P), '/RET_SEPARACAO/ListRemess/ListRemess/ListItens/ListItens/ITEMListItens') AS ITENS
                   FROM TABLE(XMLSEQUENCE(EXTRACT(L_XMLTYPE, '//RET_SEPARACAO'))) P)
   LOOP
      FOR C_ITENS IN (SELECT EXTRACTVALUE(VALUE(ITENS), 'ITEMListItens/CODPRODUTO/text()') AS CODPRODUTO
                            ,EXTRACTVALUE(VALUE(ITENS), 'ITEMListItens/QUANTIDADE/text()') AS QUANTIDADE
                        FROM TABLE(XMLSEQUENCE(EXTRACT(C_XML.ITENS, '/ITEMListItens'))) ITENS)
      LOOP
         INSERT INTO RETORNO_ARQ_SEPARA(EMPRESA, FILIAL, ORDEMCARREGAMENTO, CODPRODUTO, QUANTIDADE, DEPOSITO_ERP)
         VALUES(C_XML.EMPRESA, C_XML.FILIAL, C_XML.ORDEMCARREGAMENTO, C_ITENS.CODPRODUTO, C_ITENS.QUANTIDADE, C_XML.DEPOSITO_ERP);
      END LOOP;
   END LOOP;

   COMMIT;

   V_IDEXISTEPED := 'N';

   OPEN C_RET_SEPARACAO;
   LOOP
      FETCH C_RET_SEPARACAO INTO V_CDFILIAL, V_PEDIDO, V_CDFILDEST, V_CDFILLANC, V_NRPEDEXOL, V_CODPRODUTO,
                                 V_QUANTIDADE;
      EXIT WHEN C_RET_SEPARACAO%NOTFOUND;

      V_ERRO := NULL;
      V_IDEXISTEPED := 'S';

      BEGIN
         SELECT CDFILDEST
           INTO V_PEDEXISTE
           FROM PEDIDOEXOL
          WHERE CDFILDEST = V_CDFILDEST
            AND CDFILLANC = V_CDFILLANC
            AND NRPEDEXOL = V_NRPEDEXOL;

      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_PEDEXISTE := NULL;
      END;

      IF V_PEDEXISTE IS NULL THEN
         INSERE_LOGITEM(V_SEQLOGITEM);
         V_DESCERRO := 'Pedido no cadastrado.';

         INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
         VALUES('Retorno_Separao Pedido', V_PEDIDO, V_DESCERRO, '2', V_SEQLOGITEM);

         V_ERRO := 'S';
      END IF;

      IF V_ERRO IS NULL THEN
         BEGIN
            SELECT MAX(CDPRARVORIG)
              INTO V_CDPRODUTO
              FROM PRODUTO P, RELACPRODOL R
             WHERE P.CDARVPROD = V_CODPRODUTO
               AND R.CDPRODARVOL = P.CDPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDPRODUTO := NULL;
         END;
         
         IF V_CDPRODUTO IS NOT NULL THEN
            IF NVL(V_QUANTIDADE, 0) = 0 THEN
               UPDATE ITEMPEDEXOL
                  SET IDBAIXAOLSAI = '3',
                      IDBAIXENPEOL = '3'
                WHERE CDFILDEST    = V_CDFILDEST
                  AND CDFILLANC    = V_CDFILLANC
                  AND NRPEDEXOL    = V_NRPEDEXOL
                  AND CDPRODUTO    = V_CDPRODUTO;

--               V_NRPEDEXOLANT := V_PEDIDO;
            END IF;
            
            -- Altera a quantidade atendida do pedido OL
            UPDATE ITEMPEDEXOL
               SET QTATENDPEDOL = NVL(V_QUANTIDADE, 0),
                   QTVOLUPEDOL  = NVL(V_QUANTIDADE, 0)
             WHERE CDFILDEST    = V_CDFILDEST
               AND CDFILLANC    = V_CDFILLANC
               AND NRPEDEXOL    = V_NRPEDEXOL
               AND CDPRODUTO    = V_CDPRODUTO;
               
            -- Altera a quantidade reservada referente ao pedido do OL
            UPDATE RESERVAPEDEXOL
               SET QTRESERVESTOL = V_QUANTIDADE
             WHERE CDFILDEST     = V_CDFILDEST
               AND CDFILLANC     = V_CDFILLANC
               AND NRPEDEXOL     = V_NRPEDEXOL
               AND CDPRODUTO     = V_CDPRODUTO;
         ELSE
            --DBMS_OUTPUT.PUT_LINE('PONTO 5 ');
            INSERE_LOGITEM(V_SEQLOGITEM);
            V_DESCERRO := 'Produto '|| V_CODPRODUTO || ' no cadastrado.';
            INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
            VALUES('Retorno_Separao Pedido', V_PEDIDO, V_DESCERRO, '2', V_SEQLOGITEM);

            V_ERRO := 'S';
         END IF;
      END IF;

      IF V_ERRO IS NULL THEN
         INSERE_LOGITEM(V_SEQLOGITEM);
         INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
         VALUES('Retorno_Separao Pedido', V_PEDIDO, V_ERRO, '2', V_SEQLOGITEM);
      END IF;
   END LOOP;

   IF V_IDEXISTEPED = 'N' THEN
      V_DESCERRO := 'No foi encontrado retorno de pedido.';
   END IF;

   COMMIT;

   P_ERRO := V_DESCERRO;
   CLOSE C_RET_SEPARACAO;
EXCEPTION
   WHEN OTHERS THEN
      IF C_RET_SEPARACAO%ISOPEN THEN
         CLOSE C_RET_SEPARACAO;
      END IF;

      INSERE_LOGITEM(V_SEQLOGITEM);
      V_DESCERRO := SQLERRM(SQLCODE);
      --DBMS_OUTPUT.PUT_LINE('PONTO 7 '||V_DESCERRO);
      P_ERRO := V_DESCERRO;
      INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
      VALUES('Retorno_Separao Pedido', V_PEDIDO, V_DESCERRO, '2', V_SEQLOGITEM);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('MHA_IMPORTA_RET_SEPARACAO','5.87.XXX'); END;
/